(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["Flex"] = factory(require("react"));
	else
		root["Flex"] = factory(root["react"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});

	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

	exports.default = Flex;

	var _react = __webpack_require__(1);

	var _react2 = _interopRequireDefault(_react);

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

	function Flex(props) {
	  var style = {
	    flex: '0 1 auto'
	  };

	  var aligningValues = {
	    row: {
	      justify: {
	        left: 'flex-start',
	        center: 'center',
	        right: 'flex-end'
	      },
	      align: {
	        top: 'flex-start',
	        center: 'center',
	        bottom: 'flex-end',
	        stretch: 'stretch'
	      }
	    },
	    column: {
	      justify: {
	        top: 'flex-start',
	        center: 'center',
	        bottom: 'flex-end'
	      },
	      align: {
	        left: 'flex-start',
	        center: 'center',
	        right: 'flex-end',
	        stretch: 'stretch'
	      }
	    },
	    flip: {
	      column: {
	        justify: {
	          top: 'left',
	          center: 'center',
	          bottom: 'right'
	        },
	        align: {
	          left: 'top',
	          center: 'center',
	          right: 'bottom',
	          stretch: null
	        }
	      }
	    }
	  };

	  var direction = 'row';

	  if (props.row || props.column && !Array.isArray(props.children)) {
	    style.display = 'flex';
	    style.flexDirection = 'row';
	    direction = 'row';
	  }
	  if (props.reverseRow || props.reverseColumn && !Array.isArray(props.children)) {
	    style.display = 'flex';
	    style.flexDirection = 'row-reverse';
	  }

	  if (props.column && Array.isArray(props.children)) {
	    style.display = 'flex';
	    style.flexDirection = 'column';
	    direction = 'column';
	  }
	  if (props.reverseColumn && Array.isArray(props.children)) {
	    style.display = 'flex';
	    style.flexDirection = 'column-reverse';
	  }

	  if (props.alignSelf) {
	    style.alignSelf = {
	      top: 'flex-start',
	      right: 'flex-end',
	      bottom: 'flex-end',
	      left: 'flex-start'
	    }[props.alignSelf];
	  }

	  if (props.wrap) {
	    style.flexWrap = 'wrap';
	  }
	  if (props.reverseWrap) {
	    style.flexWrap = 'wrap-reverse';
	  }

	  if (!props.row && !props.column && !props.reverseRow && !props.reverseColumn && (props.align || props.alignVertical || props.alignHorizontal)) {
	    direction = 'row';
	    style.display = 'flex';
	    style.flexDirection = 'row';
	  }

	  var align = 'left top';
	  if (props.align) {
	    align = props.align;
	  } else if (props.alignHorizontal && props.alignVertical) {
	    align = direction === 'row' ? props.alignHorizontal + ' ' + props.alignVertical : props.alignVertical + ' ' + props.alignHorizontal;
	  } else if (props.alignVertical) {
	    align = direction === 'row' ? 'left ' + props.alignVertical : props.alignVertical;
	  } else if (props.alignHorizontal) {
	    align = direction === 'row' ? props.alignHorizontal : 'top ' + props.alignHorizontal;
	  }

	  if (props.align || props.alignVertical || props.alignHorizontal) {
	    var alignment = align.split(' ');
	    if (props.column && direction === 'row' || props.reverseColumn && direction === 'row') {
	      direction = 'column';
	      alignment = alignment.length === 1 ? ['top', alignment[0]] : [aligningValues.flip.column.align[alignment[1]], alignment[0]];
	    }
	    style.justifyContent = aligningValues[direction].justify[alignment[0]];
	    if (alignment[1]) {
	      style.alignItems = aligningValues[direction].align[alignment[1]];
	    }
	    if (alignment[1] && Array.isArray(props.children)) {
	      style.alignContent = aligningValues[direction].align[alignment[1]];
	    }
	  }

	  if (props.grow) {
	    style.flexGrow = props.grow === true ? '1' : String(props.grow);
	  }

	  if (props.order) {
	    style.order = String(props.order);
	  }

	  if (props.style) {
	    style = Object.assign(style, props.style);
	  }

	  var ownPropKeys = ['align', 'alignVertical', 'alignHorizontal', 'grow', 'order', 'row', 'reverseRow', 'column', 'reverseColumn', 'wrap', 'reverseWrap', 'alignSelf'];
	  var passProps = Object.keys(props).filter(function (key) {
	    return ownPropKeys.indexOf(key) === -1;
	  }).reduce(function (obj, key) {
	    obj[key] = props[key];
	    return obj;
	  }, {});

	  return _react2.default.createElement(
	    'div',
	    _extends({}, passProps, { style: style }),
	    props.children
	  );
	}

	Flex.propTypes = {
	  children: _react2.default.PropTypes.any,
	  align: _react2.default.PropTypes.string,
	  alignVertical: _react2.default.PropTypes.string,
	  alignHorizontal: _react2.default.PropTypes.string,
	  grow: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.bool, _react2.default.PropTypes.number]),
	  order: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
	  row: _react2.default.PropTypes.bool,
	  reverseRow: _react2.default.PropTypes.bool,
	  column: _react2.default.PropTypes.bool,
	  reverseColumn: _react2.default.PropTypes.bool,
	  wrap: _react2.default.PropTypes.bool,
	  reverseWrap: _react2.default.PropTypes.bool,
	  style: _react2.default.PropTypes.object,
	  alignSelf: _react2.default.PropTypes.string
	};

/***/ },
/* 1 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ }
/******/ ])
});
;